/********************************************************************\

  Name:         ybosdmp.c
  Created by:   Pierre-Andre Amaudruz

  Contents:     Dump event on screen withYBOS format


  Revision history
  ------------------------------------------------------------------
  date        by    modification
  --------    ---   ------------------------------------------------
  11-OCT-96   PAA   created

\********************************************************************/
#include "midas.h"
#include "msystem.h"
#include "ybos.h"

#define EVENT_SIZE (NET_BUFFER_SIZE-100)

char   bank_name[4], sbank_name[4], svpath[128];
INT    hBufEvent;
INT    static evt_display=0;
INT    speed=0, dsp_time=0, dsp_fmt=0, dsp_mode=0, file_mode;
BOOL   via_callback;
char   event_buffer[10000];
INT    count;                    
/*----- receive_event ----------------------------------------------*/

void process_event(HNDLE hBuf, HNDLE request_id, EVENT_HEADER *pheader)
{
  DWORD *pevt, *pbk, bklen, bktyp;
  INT i, fswap, status, size;
  char banklist[512];

  if (speed == 1)
    {
      /* accumulate received event size */
      size = pheader->data_size;
      count += size;
      return;
    }
  if (evt_display > 0)
    {
      evt_display--;

      /* pointer to ybos bank */
      pevt = (DWORD *) ((EVENT_HEADER *)(pheader+1));
      
      /* swap byte if necessary based on the YBOS bank type */
      fswap = ybos_swap_event(pevt);
      
      if (file_mode != NO_RECOVER)
	{
	  status = ybos_file_compose((char *)pevt, svpath, file_mode);  
	  printf("ybos_file_compose(status):%d\n",status);
	}
      if (sbank_name[0] != 0)
	{
	  if (ybkfind (pevt,sbank_name,&bklen,&bktyp,&pbk) == YBOS_SUCCESS)
	    {
	      printf("------------------------ Event# %i --------------------------------\n",evt_display);
	      printf("Evid:%4.4x- Mask:%4.4x- Serial:%i- Time:0x%x- Dsize:%i/0x%x\n"
		,pheader->event_id, pheader->trigger_mask ,pheader->serial_number
		, pheader->time_stamp, pheader->data_size, pheader->data_size);
	      status = ybklist (pevt,banklist);
	      printf("#banks:%i Bank list:-%s-\n",status,banklist);
	      printf("Bank:%s - Length:%i - Type:%i - pBk:0x%p\n",sbank_name, bklen,bktyp,pbk);
	      ybos_display_any_bank(pbk,dsp_mode,dsp_fmt);
	    }
	  else
	    printf("%s not found\n",sbank_name);
	}	  
      else
	{
	  /* pevt -> to lrl */
	  printf("------------------------ Event# %i --------------------------------\n",evt_display);
	  printf("Evid:%4.4x- Mask:%4.4x- Serial:%i- Time:0x%x- Dsize:%i/0x%x\n"
		 ,pheader->event_id, pheader->trigger_mask ,pheader->serial_number
		 , pheader->time_stamp, pheader->data_size, pheader->data_size);
	  status = ybklist (pevt,banklist);
	  printf("#banks:%i - Bank list:-%s-\n",status,banklist);
	  if (dsp_mode == DSP_RAW)
	    {
	      ybos_display_any_event(pevt,dsp_mode,dsp_fmt);
	    }
	  else
	    {
	      for (i=0;banklist[i]!=0;i+=4)
		{
		  strncpy(&bank_name[0],&banklist[i],4);
		  if (ybkfind (pevt,bank_name,&bklen,&bktyp,&pbk) == YBOS_SUCCESS)  
		    ybos_display_any_bank(pbk,dsp_mode,dsp_fmt);
		}
	    }
	}
      if (evt_display == 0)
	{
	  cm_disconnect_experiment();
	  exit(0);
	}
      if (dsp_time != 0)
	ss_sleep(dsp_time);
    }
  return;
}  

/*------------------------------------------------------------------*/
 int main(unsigned int argc,char **argv)
{
  char   ch, host_name[HOST_NAME_LENGTH], expt_name[HOST_NAME_LENGTH], str[30];       
  unsigned int narg;
  char *event;
  double        rate;
  INT    j, status, start_time, stop_time;
  INT    read_cache_size;            
  INT    event_id, request_id, size, get_flag;
  BUFFER_HEADER buffer_header;
  
  /* set default */
  cm_get_environment (host_name, expt_name);
  sbank_name[0]=0;
  svpath[0]=0;
  event_id = -1; 
  evt_display = 1; 
  get_flag = GET_SOME;
  dsp_fmt = DSP_HEX;
  dsp_mode= DSP_YBOS;
  file_mode = NO_RECOVER;
  via_callback = TRUE;
  dsp_time = 0;
  speed = 0;
  /* get parameters */
  narg = 0;
  j = 0;
  while (narg < argc)
    {
      strcpy(str,argv[j]);
      if (strncmp(str,"-he",3) == 0)
	{
	  printf("ybosdmp -id(1) -bk bank_name  -display(1)  -delay(0)  -mode(Y/r)\n");
	  printf("        -get(Some/all)  -format(X/d/a) -expt(Default) -host(local)\n");
	  printf("        -speed -path (null)  -file (Skip/addrun/norun)\n");
	  return 0;
	}
      if (strncmp(str,"-id",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  event_id = atoi (str);
	}
      else if (strncmp(str,"-mo",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  if (strncmp(str,"r",1)==0)
	    dsp_mode = DSP_RAW;
	  if (strncmp(str,"y",1)==0)
	    dsp_mode = DSP_YBOS;
	}
      else if (strncmp(str,"-fo",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  if (strncmp(str,"d",1)==0)
	    dsp_fmt = DSP_DEC;
	  if (strncmp(str,"x",1)==0)
	    dsp_fmt = DSP_HEX;
	  if (strncmp(str,"a",1)==0)
	    dsp_fmt = DSP_ASC;
	}
      else if (strncmp(str,"-fi",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  if (strncmp(str,"s",1)==0)
	    file_mode = NO_RECOVER;
	  if (strncmp(str,"n",1)==0)
	    file_mode = NO_RUN;
	  if (strncmp(str,"a",1)==0)
	    file_mode = ADD_RUN;
	}
      else if (strncmp(str,"-ho",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  sprintf(host_name,str);
	}
      else if (strncmp(str,"-pa",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  sprintf(svpath,str);
	}
      else if (strncmp(str,"-bk",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  strncpy(sbank_name,str,4);
	}
      else if (strncmp(str,"-ex",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  sprintf(expt_name,str);
	}
      else if (strncmp(str,"-di",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  evt_display = atoi (str);
	}
      else if (strncmp(str,"-ge",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  if (strncmp(str,"s",1)==0)
	    get_flag = GET_SOME;
	  if (strncmp(str,"a",1)==0)
	    get_flag = GET_ALL;
	}
      else if (strncmp(str,"-de",3) == 0)
	{
	  sprintf (str,argv[++j]);
	  narg++;
	  dsp_time = 1000 * (atoi (str));
	}
      else if (strncmp(str,"-sp",3) == 0)
	{
	  speed = 1;
	  j++;
	  narg++;
	}
      else
	{
	  j++;
	  narg++;
	}
    }
  
  /* check parameters */
  if (evt_display < 1 && evt_display > 1000)
    {
      printf("ybosdmp-F- <-display arg> out of range (1:1000)\n");
      return -1;
    }
    if(dsp_time < 0 && dsp_time > 100) 
    {
      printf("ybosdmp-F- <-delay arg> out of range (1:100)\n");
      return -1;
    }
    if(dsp_fmt == 0)
      {
      printf("ybosdmp-F- <-format arg> invalid (x,d)\n");
      return -1;
    }
  
  /* connect to experiment */
  status = cm_connect_experiment(host_name, expt_name, "YbosDmp", 0);
  if (status == CM_WRONG_PASSWORD)
    printf("Wrong password\n");
  else if (status == CM_UNDEF_EXP)
    printf("Experiment \"%s\" not defined\n", expt_name);
  else if (status == RPC_NET_ERROR)
    printf("Cannot connect to remote host %s\n", host_name);
  else if (status == CM_UNDEF_ENVIRON)
    printf("\"exptab\" file not found and MIDAS_DIR environment variable not defined\n");
  else if (status != CM_SUCCESS)
    printf("Internal error %d, cannot connect to experiment\n", status);
  if (status != CM_SUCCESS)
    return 1;
  
#ifdef _DEBUG
  cm_set_watchdog_params(TRUE, 0);
#endif
  
  /* open the "system" buffer, 1M size */
  bm_open_buffer("SYSTEM", EVENT_BUFFER_SIZE, &hBufEvent);
  
  /* set the buffer cache size if requested */
  bm_set_cache_size(hBufEvent, 100000, 0);
  
  /* place a request for a specific event id */
  bm_request_event(hBufEvent, (WORD) event_id, TRIGGER_ALL,
		   get_flag, &request_id, process_event);
  
  start_time = 0;
  if (speed == 1)
    printf("-%1.2lf -- Enter <!> to Exit ------- Ybos Dump in Speed test mode ---\n"
    ,cm_get_version()/100.0);
  else
    printf("-%1.2lf -- Enter <!> to Exit ------- Ybos Dump ---\n"
    ,cm_get_version()/100.0);
  do
    {
      if (via_callback)
	{
	  status = cm_yield(1000);
	  if (ss_kbhit())
	    {
#if defined(OS_MSDOS) || defined(OS_WINNT)
	      ch = getch();
#else
	      ch = getchar();
#endif
	      if (ch == '!')
		break;
	    }
	}
      if (speed == 1)
	{
	  /* calculate rates each second */
	  if (ss_millitime() - start_time > 1000)
	    {
	      stop_time = ss_millitime();
	      rate = count / 1024.0 / 1024.0 / ((stop_time-start_time)/1000.0);
	      
	      /* get information about filling level of the buffer */
	      bm_get_buffer_info(hBufEvent, &buffer_header);
	      size = buffer_header.read_pointer - buffer_header.write_pointer;
	      if (size <= 0)
		size += buffer_header.size;
	      printf("Level: %4.3lf %%, ", 100-100.0*size/buffer_header.size);
	      
	      printf("Rate: %1.3lf MB/sec\n", rate);
              if (ss_kbhit())
                {
#if defined(OS_MSDOS) || defined(OS_WINNT)
                  ch = getch();
#else
                  ch = getchar();
#endif
                  if (ch == '!')
                    break;
                }
 	      start_time = stop_time;
	      count = 0;
	    }
	}      
    } while (status != RPC_SHUTDOWN && status != SS_ABORT);
  
  cm_disconnect_experiment();
  
  return 1;
}
