#include <vxWorks.h>
#include <adpLib.h>
#include <AXPvme.h>
#include <stdio.h>
#include <stdlib.h>
#include "midas.h"

/*------------------------------------------------------------------*/

main1()
{
INT           i, flag;
INT           size, count;
INT           start, stop;
double        rate;
char          *p1, *p2, *p3;

struct adp    *vmeAdapter;
struct adp    *primaryAdapter = NULL;
int           node = 0;
u_long        pioSrcAddress = -1;
void          *pioHandle;
u_long        pioRealSize;
u_long        pioGranularity;


  printf("Size : ");
  scanf("%d", &size);

  /* do VME mapping */
  vmeAdapter = adpLookup(VME_VECTOR(0,0));
  i = adpCreateMapPath(primaryAdapter,
                   vmeAdapter,
                   0x10000000,              /* destination address */
                   size,                    /* window size */
                   0,                       /* node */
                   ADDRESS_SPACE_A32 + 
                     ADDRESS_SPACE_SUP +
                     ADDRESS_SPACE_SPARSE,
                   ACCESS_TYPE_NO_SWAP,
                   &pioSrcAddress,
                   &pioHandle,
                   &pioRealSize,
                   &pioGranularity);

  printf("local mem -> local mem (1)    VME mem -> local mem (2)\n");
  printf("local mem -> VME   mem (3) : ");
  scanf("%d", &flag);

  p1 = malloc(size);
  p2 = malloc(size);

  if (p1 == NULL || p2 == NULL)
    {
    printf("not enough local memeory");
    return 0;
    }

  for (i=0 ; i<size ; i++)
    p1[i] = i;

  do
    {
    start = ss_millitime();
    count = 0;

    do
      {
      if (flag == 1)
        memcpy(p2, p1, size);
      else if (flag == 2)
        adpMemRead(vmeAdapter, pioSrcAddress, 0, size, ACCESS_TYPE_QUAD_WORD, p2);
      else if (flag == 3)
        adpMemWrite(vmeAdapter, pioSrcAddress, 0, size, ACCESS_TYPE_QUAD_WORD, p2);

      count += size;

      /* repeat this loop for 1s */
      } while (ss_millitime() - start < 1000);

    /* Now calculate the rate */
    stop = ss_millitime();
    if (stop != start)
      rate =  count / 1024.0 / 1024.0 / (stop/1000.0 - start/1000.0);
    else
      rate = 0;

    printf("Rate: %1.2lf MB/sec\n", rate);
    } while (!ss_kbhit());
  
  free(p1);
  free(p2);
}
